#!/bin/sh
exec scala "$0"
!#

Surf.main(args)

import vastblue.core.Rankable

/** this trait compiled separately and added to the classpath:
trait Rankable {
  var rank:Double = 0.0
  import Numeric.Implicits._
  def updateRank[T:Numeric](r:T){ rank += r.toDouble }
}
*/

object Surf extends App {
  val strats = List[Strategy](Strategy("name1"))
  strats.sortBy { - _.score }.zipWithIndex.foreach { case (c,i) => c.updateRank(i) }
  strats.foreach { printf("%s\n",_) }
}

class Strategy(name:String) extends Rankable {
  import Strategy._
  def score = 1
  override def toString = "%4.2f: %s".format(rank,name)
}

object Strategy {
  def apply(name:String):Strategy = new Strategy(name)
}

